;***************************************
LIST P=16F84
TMR0 equ 1
pc equ 2
STATUS equ 3
fsr equ 4
PORTA equ 5
PORTB equ 6
TRISA equ 85h
TRISB equ 86h
INTCON equ 0bh
OPTIONS equ 81h
;==================================
z equ 2h
c equ 0h
w equ 0h
r equ 1h
RP0 equ 5H
rbpu equ 7
intedg equ 6
intf equ 1
inte equ 4
gie equ 7
t0if equ 2
t0ie equ 5
psa equ 3
t0cs equ 5
led1 equ 0
TRIAC equ 1
s1 equ 3
s2 equ 4
;========================RAM
r13 equ 15h
r14 equ 16h
contador que 17h
tempor equ 18h
W_TEMP equ 19h
STATUS_TEMP equ 1ah

;************ PROGRAMA *********
;=============================
org 00H
;=============================
goto inicio 		;Pula para o incio do programa principal.
;=============================
org 04H
;=============================
;
interrup ;Endereo de interrupes gerais.
;-
PUSH
MOVWF W_TEMP 		; Copia W no registro W_TEMP.
SWAPF STATUS, W 	; Intercambia os nibbles de STATUS para serem salvos em W.
MOVWF STATUS_TEMP 	; Salva STATUS para o registro STATUS_TEMP
btfss INTCON,intf 	;Testa se  a interrupo externa.

goto int_timer0
movlw 0FEH 		;Rotina de interrupo externa.
movwf TMR0 		;Recarrega o timer 0.
bcf INTCON,t0if 	;Limpa o aviso de interrupo do timer 0.
bsf INTCON,t0ie 	;Habilita o timer0.
bsf PORTA,TRIAC 	;Desconecta o TRIAC.
movfw contador 		;Move o "contador" para "tempor".
movwf tempor
bcf INTCON,intf 	;Limpa o aviso de interrupo externa.
goto sai_interrup 	;Pula para sair da interrupo externa.
int_timer0
btfss INTCON,t0if 	;Testa se  a interrupo do timer 0.
goto sai_int_t0
decfsz tempor,r 	;Decrementa o registro "tempor".
goto recarga_t0
bcf PORTA,TRIAC 	;Conecta o TRIAC.
bcf INTCON,t0ie 	;Para o timer 0.
goto sai_int_t0 	;Pula para sair da interrupo do timer 0.
recarga_t0
movlw 0FEH 		;Recarrega o timer 0.
movwf TMR0
bsf INTCON,t0ie 	;Habilita a contagem no timer 0.
sai_int_t0
bcf INTCON,t0if 	;Limpa o aviso de interrupes do timer 0.

;================================
sai_interrup
POP
SWAPF STATUS_TEMP, W	;Intercambia nibbles no registro STATUS_TEMP. e coloca o resultado em W.
MOVWF STATUS 		; Move W dentro do registro STATUS.
SWAPF W_TEMP, F 	;Intercambia nibbles em W_TEMP e deixa o resultado W_TEMP.
SWAPFW_TEMP, W 		;Intercambia nibbles em W_TEMP e deixa o resultado em W.
retfie 			;Retorno de interrupes.

;**************************************
inicio
;**************************************
bsf STATUS,RP0 		;Seleciona o banco 1 da memria RAM.
movlw 0ffh 		;Configura a porta B como entrada.
movwf TRISB
movlw 00h 		;Configura a porta A como sada.
movwf TRISA
bcf OPTIONS,rbpu 	;Seleciona pull-up na porta B.
bcf OPTIONS,psa 	;Seleciona o pr-escalar para o timer 0.
bcf OPTIONS,t0cs 	;Seleciona o timer 0 com o clock de instrues.
bcf STATUS,RP0 		;Seleciona o banco 0 da memria RAM.

;========================================================
movlw 3 		;Carrega o "contador" com o valor 3.
movwf contador
bsf INTCON,inte 	;Habilita a interrupo externa.
bsf INTCON,gie 		;Habilita o bit global de interrupes.

;=======================================
Test_s1
btfsc PORTB,s1 		;Testa o pulsador INC.
goto Test_s2
Re_ta_1
decfsz r13,r 		;Retarda alguns milissegundos para
goto Re_ta_1 		;evitar rudo nos pulsadores.
decfsz r14,r
goto Re_ta_1
movlw11H 		;Compara se o "contador" chegou a 11H.
subwf contador,w 	;Se o "contador" chegou a 11H ento
btfss STATUS,z 		;Pule a instruo seguinte.
incf contador,r 	;Incrementa o "contador".

;========================================================
Test_s2
btfsc PORTB,s2 		;Testa o pulsador DEC.
goto sai_test_2
Re_ta_2
decfsz r13,r 		;Retarda uns milissegundos para evitar rudo nos
goto Re_ta_2 		;pulsadores.
decfsz r14,r
goto Re_ta_2
movlw 2H 		;Compara se o "contador" chegou a 2.
subwf contador,w 	;Se o "contador" chegou a 2 ento
btfss STATUS,z 		;pule a instruo seguinte.
decf contador,r 	;Decremente o "contador".
sai_test_2
goto Test_s1 ;Pule para voltar a testar.
;========================================================
END